# video-fetcher

Fetch batches of videos without breaking a sweat.  Powered by [yt-dlp](https://github.com/yt-dlp/yt-dlp#readme)

```
Usage: video-fetcher [OPTIONS]

Options:
      --use-folders
          Use folders instead of naming the files.
          
          Similar to using the `--paths` option in yt-dlp.

  -U, --upgrade
          Upgrade the versions of yt-dlp

  -C, --only-check-setup
          Check the setup for video-fetcher.
          
          Checks if yt-dlp and ffmpeg setup as expected.

  -h, --help
          Print help (see a summary with '-h')

  -V, --version
          Print version
```

## Badges

[![Build Status](https://ci.birch-tree.net/api/badges/dorian/video-fetcher/status.svg)](https://ci.birch-tree.net/dorian/video-fetcher)

## Downloads

* [Debian 11 / Ubuntu 20.04](https://code.birch-tree.net/dorian/-/packages/generic/video-fetcher/0.4.0/)
* [Ubuntu 18.04](https://code.birch-tree.net/dorian/-/packages/generic/video-fetcher/0.4.0/)

## Development

* Install the latest version of Rust: 2021 Edition via `rustup`.
* Run tests: `cargo test`
* Build the system: `cargo build`
* [Create a Debian package using `cargo-deb`][deb]: `cargo deb`
* Read the documentation: `cargo docs --open`

[deb]: https://github.com/kornelski/cargo-deb#readme

### TODO

* [ ] Fix CI pipeline to use drone-ci git checkout properly.
* [ ] Fix issue with uploading DEB package releases.
* [ ] Add a terminal UI that lets you add, remove, save download lists and
      manage entire usage in a simple flow.  Think parted, or fdisk but nicer.
* [ ] Have a proper DEB registry to host releases, including mirror-server and
      other projects.
* [ ] Add a man page.
* [ ] Add a bash completion?
* [ ] Add a console line command, to pass commands from.

## Supplemental Documentation

* [Custom ffmpeg managed by the yt-dlp team](https://github.com/yt-dlp/FFmpeg-Builds)
  * [Fixes errors like Postprocessing...](https://github.com/yt-dlp/yt-dlp/issues/871)
* [Streaming process in Rust](https://stackoverflow.com/questions/31992237/how-would-you-stream-output-from-a-process)
* [tar trickery for flattening directories](https://stackoverflow.com/questions/5695881/how-do-i-tar-a-directory-without-retaining-the-directory-structure)
* [Test video - Gluppy the Flying Penguin](https://www.youtube.com/watch?v=qmKG_OaVWMg)
* [Issue with autogenerated subs not downloaded](https://stackoverflow.com/questions/65348109/youtube-dl-does-not-download-auto-generated-subtitles)
* [Packaging Rust images in Docker](https://blog.logrocket.com/packaging-a-rust-web-service-using-docker/)

